package de.mathema.spring.web;

import java.io.IOException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;

import de.mathema.spring.api.Subscription;

/**
 * Servlet implementation class SubscriptionServlet
 */
public class SubscriptionServlet extends HttpServlet {
	private static final long serialVersionUID = 1L;

	private Subscription subscription;
    public SubscriptionServlet() {
        
    }
    
    @Override
    public void init() throws ServletException {
    	ApplicationContext context = new ClassPathXmlApplicationContext("SpringConfigRemote.xml");
    	subscription = (Subscription) context.getBean(Subscription.class.getName());
    }

	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		subscription.confirm(Long.parseLong(request.getParameter("id")));
		RequestDispatcher rd = request.getRequestDispatcher("thanks.html");
		rd.forward(request, response);
	}

	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		String nickName = request.getParameter("nickName");
		String email = request.getParameter("email");
		
		try{
			subscription.create(nickName, email);
			RequestDispatcher rd = request.getRequestDispatcher("email.html");
			rd.forward(request, response);
		}catch (Exception e) {
			RequestDispatcher rd = request.getRequestDispatcher("subscription.jsp");
			request.setAttribute("email", email);
			request.setAttribute("nickName", nickName);
			request.setAttribute("errors", e.getMessage());
			rd.forward(request, response);
		}
	}
}
